/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2000, 2010 Oracle and/or its affiliates.
 *
 * OpenOffice.org - a multi-platform office productivity suite
 *
 * This file is part of OpenOffice.org.
 *
 * OpenOffice.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * OpenOffice.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with OpenOffice.org.  If not, see
 * <http://www.openoffice.org/license.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/

#ifndef _XMLOFF_FORMS_IFACECOMPARE_HXX_
#define _XMLOFF_FORMS_IFACECOMPARE_HXX_

#ifndef _COMPHELPER_STLTYPES_HXX_
#include <comphelper/stl_types.hxx>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_XDRAWPAGE_HPP_
#include <com/sun/star/drawing/XDrawPage.hpp>
#endif
namespace binfilter {

//.........................................................................
namespace xmloff
{
//.........................................................................

	//=====================================================================
	//= OInterfaceCompare
	//=====================================================================
	/** is stl-compliant structure for comparing Reference&lt; &lt;iface&gt; &gt; instances
	*/
	template < class IAFCE >
	struct OInterfaceCompare
		:public ::std::binary_function	<	::com::sun::star::uno::Reference< IAFCE >
										,	::com::sun::star::uno::Reference< IAFCE >
										,	bool
										>
	{
		bool operator() (const ::com::sun::star::uno::Reference< IAFCE >& lhs, const ::com::sun::star::uno::Reference< IAFCE >& rhs) const
		{
			return lhs.get() < rhs.get();
				// this does not make any sense if you see the semantics of the pointer returned by get:
				// It's a pointer to a point in memory where an interface implementation lies.
				// But for our purpose (provide a reliable less-operator which can be used with the STL), this is
				// sufficient ....
		}
	};

	typedef OInterfaceCompare< ::com::sun::star::beans::XPropertySet >	OPropertySetCompare;
	typedef OInterfaceCompare< ::com::sun::star::drawing::XDrawPage >	ODrawPageCompare;

//.........................................................................
}	// namespace xmloff
//.........................................................................

}//end of namespace binfilter
#endif // _XMLOFF_FORMS_IFACECOMPARE_HXX_

