/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2000, 2010 Oracle and/or its affiliates.
 *
 * OpenOffice.org - a multi-platform office productivity suite
 *
 * This file is part of OpenOffice.org.
 *
 * OpenOffice.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * OpenOffice.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with OpenOffice.org.  If not, see
 * <http://www.openoffice.org/license.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/
#ifndef _SVX_UNOPRNMS_HXX
#define _SVX_UNOPRNMS_HXX
namespace binfilter {

#define UNO_NAME_SHAPE_SIZE						"Size"
#define UNO_NAME_SHAPE_POSITION					"Position"

#define UNO_NAME_CHAR_COLOR						"CharColor"
#define UNO_NAME_CHAR_FONT						"CharFont"
#define UNO_NAME_CHAR_HEIGHT				    "CharHeight"
#define UNO_NAME_CHAR_POSTURE   				"CharPosture"
#define UNO_NAME_CHAR_SHADOWED  				"CharShadowed"
#define UNO_NAME_CHAR_UNDERLINE 				"CharUnderline"
#define UNO_NAME_CHAR_WEIGHT				    "CharWeight"

#define UNO_NAME_FILLSTYLE  					"FillStyle"
#define UNO_NAME_FILLCOLOR  					"FillColor"
#define UNO_NAME_FILLGRADIENT   				"FillGradient"
#define UNO_NAME_FILLHATCH  					"FillHatch"
#define UNO_NAME_FILLBITMAP 					"FillBitmap"
#define UNO_NAME_FILLBACKGROUND					"FillBackground"

#define UNO_NAME_EDGEKIND						"EdgeKind"
#define UNO_NAME_EDGELINE1DELTA					"EdgeLine1Delta"
#define UNO_NAME_EDGELINE2DELTA					"EdgeLine2Delta"
#define UNO_NAME_EDGELINE3DELTA					"EdgeLine3Delta"
#define UNO_NAME_EDGENODE1HORZDIST              "EdgeNode1HorzDist"
#define UNO_NAME_EDGENODE1VERTDIST              "EdgeNode1VertDist"
#define UNO_NAME_EDGENODE2HORZDIST              "EdgeNode2HorzDist"
#define UNO_NAME_EDGENODE2VERTDIST				"EdgeNode2VertDist"

#define	UNO_NAME_FILLBMP_OFFSET_X				"FillBitmapOffsetX"
#define	UNO_NAME_FILLBMP_OFFSET_Y				"FillBitmapOffsetY"
#define	UNO_NAME_FILLBMP_POSITION_OFFSET_X		"FillBitmapPositionOffsetX"
#define	UNO_NAME_FILLBMP_POSITION_OFFSET_Y		"FillBitmapPositionOffsetY"
#define	UNO_NAME_FILLBMP_RECTANGLE_POINT		"FillBitmapRectanglePoint"
#define	UNO_NAME_FILLBMP_TILE					"FillBitmapTile"
#define	UNO_NAME_FILLBMP_STRETCH				"FillBitmapStretch"
#define	UNO_NAME_FILLBMP_LOGICAL_SIZE			"FillBitmapLogicalSize"
#define	UNO_NAME_FILLBMP_SIZE_X					"FillBitmapSizeX"
#define	UNO_NAME_FILLBMP_SIZE_Y					"FillBitmapSizeY"
#define	UNO_NAME_FILL_TRANSPARENCE				"FillTransparence"
#define UNO_NAME_FILLBMP_MODE					"FillBitmapMode"

#define	UNO_NAME_FILL_GRADIENT_STYLE			"FillGradientStyle"
#define	UNO_NAME_FILL_GRADIENT_START_COLOR  	"FillGradientStartColor"
#define	UNO_NAME_FILL_GRADIENT_END_COLOR		"FillGradientEndColor"
#define	UNO_NAME_FILL_GRADIENT_ANGLE			"FillGradientAngle"
#define	UNO_NAME_FILL_GRADIENT_BORDER   		"FillGradientBorder"
#define	UNO_NAME_FILL_GRADIENT_OFFSET_X   		"FillGradientOffsetX"
#define	UNO_NAME_FILL_GRADIENT_OFFSET_Y 		"FillGradientOffsetY"
#define	UNO_NAME_FILL_GRADIENT_START_INTENSITY  "FillGradientStartIntensity"
#define	UNO_NAME_FILL_GRADIENT_END_INTENSITY	"FillGradientEndIntensity"
#define	UNO_NAME_FILL_GRADIENT_STEPS			"FillGradientSteps"

#define	UNO_NAME_FILL_HATCH_STYLE  				"FillHatchStyle"
#define	UNO_NAME_FILL_HATCH_COLOR   			"FillHatchColor"
#define	UNO_NAME_FILL_HATCH_DISTANCE			"FillHatchDistance"
#define	UNO_NAME_FILL_HATCH_ANGLE   			"FillHatchAngle"

#define	UNO_NAME_LINESTYLE						"LineStyle"
#define	UNO_NAME_LINEDASH						"LineDash"
#define	UNO_NAME_LINEWIDTH						"LineWidth"
#define	UNO_NAME_LINECOLOR						"LineColor"
#define UNO_NAME_LINEJOINT						"LineJoint"
#define	UNO_NAME_LINESTART						"LineStart"
#define	UNO_NAME_LINEEND						"LineEnd"
#define	UNO_NAME_LINESTARTWIDTH					"LineStartWidth"
#define	UNO_NAME_LINEENDWIDTH					"LineEndWidth"
#define	UNO_NAME_LINESTARTCENTER				"LineStartCenter"
#define	UNO_NAME_LINEENDCENTER					"LineEndCenter"
#define	UNO_NAME_LINETRANSPARENCE				"LineTransparence"

#define	UNO_NAME_SHADOW							"Shadow"
#define	UNO_NAME_SHADOWCOLOR					"ShadowColor"
#define	UNO_NAME_SHADOWXDIST					"ShadowXDistance"
#define	UNO_NAME_SHADOWYDIST					"ShadowYDistance"
#define	UNO_NAME_SHADOWTRANSPARENCE				"ShadowTransparence"

#define	UNO_NAME_EDGERADIUS						"CornerRadius"

#define	UNO_NAME_TEXT_MINFRAMEHEIGHT			"TextMinimumFrameHeight"
#define	UNO_NAME_TEXT_AUTOGROWHEIGHT			"TextAutoGrowHeight"
#define	UNO_NAME_TEXT_FITTOSIZE					"TextFitToSize"
#define	UNO_NAME_TEXT_LEFTDIST					"TextLeftDistance"
#define	UNO_NAME_TEXT_RIGHTDIST					"TextRightDistance"
#define	UNO_NAME_TEXT_UPPERDIST					"TextUpperDistance"
#define	UNO_NAME_TEXT_LOWERDIST					"TextLowerDistance"
#define	UNO_NAME_TEXT_VERTADJUST				"TextVerticalAdjust"
#define	UNO_NAME_TEXT_MAXFRAMEHEIGHT			"TextMaximumFrameHeight"
#define	UNO_NAME_TEXT_MINFRAMEWIDTH				"TextMinimumFrameWidth"
#define	UNO_NAME_TEXT_MAXFRAMEWIDTH				"TextMaximumFrameWidth"
#define	UNO_NAME_TEXT_AUTOGROWWIDTH				"TextAutoGrowWidth"
#define	UNO_NAME_TEXT_HORZADJUST				"TextHorizontalAdjust"
#define	UNO_NAME_TEXT_ANIKIND					"TextAnimationKind"
#define	UNO_NAME_TEXT_ANIDIRECTION				"TextAnimationDirection"
#define	UNO_NAME_TEXT_ANISTARTINSIDE			"TextAnimationStartInside"
#define	UNO_NAME_TEXT_ANISTOPINSIDE				"TextAnimationStopInside"
#define	UNO_NAME_TEXT_ANICOUNT					"TextAnimationCount"
#define	UNO_NAME_TEXT_ANIDELAY					"TextAnimationDelay"
#define	UNO_NAME_TEXT_ANIAMOUNT					"TextAnimationAmount"
#define	UNO_NAME_TEXT_CONTOURFRAME				"TextContourFrame"
#define UNO_NAME_TEXT_WRITINGMODE				"TextWritingMode"

#define	UNO_NAME_MEASUREKIND					"MeasureKind"
#define	UNO_NAME_MEASURETEXTHPOS				"MeasureTextHorizontalPosition"
#define	UNO_NAME_MEASURETEXTVPOS				"MeasureTextVerticalPosition"
#define	UNO_NAME_MEASURELINEDIST				"MeasureLineDistance"
#define	UNO_NAME_MEASUREHELPLINEOVERHANG		"MeasureHelpLineOverhang"
#define	UNO_NAME_MEASUREHELPLINEDIST			"MeasureHelpLineDistance"
#define	UNO_NAME_MEASUREHELPLINE1LEN			"MeasureHelpLine1Length"
#define	UNO_NAME_MEASUREHELPLINE2LEN			"MeasureHelpLine2Length"
#define	UNO_NAME_MEASUREBELOWREFEDGE			"MeasureBelowReferenceEdge"
#define	UNO_NAME_MEASURETEXTROTA90				"MeasureTextRotate90"
#define	UNO_NAME_MEASURETEXTUPSIDEDOWN			"MeasureTextUpsideDown"
#define	UNO_NAME_MEASUREOVERHANG				"MeasureOverhang"
#define	UNO_NAME_MEASUREUNIT					"MeasureUnit"
#define	UNO_NAME_MEASURESCALE					"MeasureScale"
#define	UNO_NAME_MEASURESHOWUNIT				"MeasureShowUnit"
#define	UNO_NAME_MEASUREFORMATSTRING			"MeasureFormatString"
#define	UNO_NAME_MEASURETEXTAUTOANGLE			"MeasureTextAutoAngle"
#define	UNO_NAME_MEASURETEXTAUTOANGLEVIEW		"MeasureTextAutoAngleView"
#define	UNO_NAME_MEASURETEXTISFIXEDANGLE		"MeasureTextIsFixedAngle"
#define	UNO_NAME_MEASURETEXTFIXEDANGLE			"MeasureTextFixedAngle"

#define	UNO_NAME_CIRCKIND						"CircleKind"
#define	UNO_NAME_CIRCSTARTANGLE					"CircleStartAngle"
#define	UNO_NAME_CIRCENDANGLE					"CircleEndAngle"

#define	UNO_NAME_POLYGONKIND					"PolygonKind"
#define	UNO_NAME_POLYPOLYGON					"PolyPolygon"
#define	UNO_NAME_POLYPOLYGONBEZIER				"PolyPolygonBezier"
#define UNO_NAME_POLYGON						"Polygon"

#define UNO_NAME_MISC_OBJ_ZORDER				"ZOrder"
#define	UNO_NAME_MISC_OBJ_MOVEPROTECT			"MoveProtect"
#define	UNO_NAME_MISC_OBJ_SIZEPROTECT			"SizeProtect"
#define	UNO_NAME_MISC_OBJ_PRINTABLE				"Printable"
#define	UNO_NAME_MISC_OBJ_LAYERID				"LayerID"
#define	UNO_NAME_MISC_OBJ_LAYERNAME				"LayerName"
#define	UNO_NAME_MISC_OBJ_NAME					"Name"
#define	UNO_NAME_MISC_OBJ_ROTATEANGLE			"RotateAngle"
#define	UNO_NAME_MISC_OBJ_SHEARANGLE			"ShearAngle"
#define	UNO_NAME_MISC_OBJ_ROTATION_POINT_X		"RotationPointX"
#define	UNO_NAME_MISC_OBJ_ROTATION_POINT_Y		"RotationPointY"
#define UNO_NAME_MISC_OBJ_FRAMERECT				"FrameRect"
#define UNO_NAME_MISC_OBJ_BOUNDRECT				"BoundRect"

#define	UNO_NAME_GRAPHOBJ_FILLBITMAP			"GraphicObjectFillBitmap"
#define UNO_NAME_GRAPHOBJ_GRAFURL				"GraphicURL"
#define UNO_NAME_GRAPHOBJ_GRAFSTREAMURL			"GraphicStreamURL"
#define UNO_NAME_GRAPHOBJ_URLPREFIX				"vnd.sun.star.GraphicObject:"
#define UNO_NAME_GRAPHOBJ_URLPKGPREFIX			"vnd.sun.star.Package:"

#define UNO_NAME_OLE2_METAFILE                  "MetaFile"
#define UNO_NAME_OLE2_PERSISTNAME               "PersistName"

#define	UNO_NAME_3D_SCENE_PERSPECTIVE			"D3DScenePerspective"
#define	UNO_NAME_3D_SCENE_DISTANCE				"D3DSceneDistance"
#define	UNO_NAME_3D_SCENE_FOCAL_LENGTH			"D3DSceneFocalLength"
#define	UNO_NAME_3D_SCENE_TWO_SIDED_LIGHTING	"D3DSceneTwoSidedLighting"
#define	UNO_NAME_3D_SCENE_LIGHTCOLOR_1			"D3DSceneLightColor1"
#define	UNO_NAME_3D_SCENE_LIGHTCOLOR_2			"D3DSceneLightColor2"
#define	UNO_NAME_3D_SCENE_LIGHTCOLOR_3			"D3DSceneLightColor3"
#define	UNO_NAME_3D_SCENE_LIGHTCOLOR_4			"D3DSceneLightColor4"
#define	UNO_NAME_3D_SCENE_LIGHTCOLOR_5			"D3DSceneLightColor5"
#define	UNO_NAME_3D_SCENE_LIGHTCOLOR_6			"D3DSceneLightColor6"
#define	UNO_NAME_3D_SCENE_LIGHTCOLOR_7			"D3DSceneLightColor7"
#define	UNO_NAME_3D_SCENE_LIGHTCOLOR_8			"D3DSceneLightColor8"
#define	UNO_NAME_3D_SCENE_LIGHTON_1				"D3DSceneLightOn1"
#define	UNO_NAME_3D_SCENE_LIGHTON_2				"D3DSceneLightOn2"
#define	UNO_NAME_3D_SCENE_LIGHTON_3				"D3DSceneLightOn3"
#define	UNO_NAME_3D_SCENE_LIGHTON_4				"D3DSceneLightOn4"
#define	UNO_NAME_3D_SCENE_LIGHTON_5				"D3DSceneLightOn5"
#define	UNO_NAME_3D_SCENE_LIGHTON_6				"D3DSceneLightOn6"
#define	UNO_NAME_3D_SCENE_LIGHTON_7				"D3DSceneLightOn7"
#define	UNO_NAME_3D_SCENE_LIGHTON_8				"D3DSceneLightOn8"
#define	UNO_NAME_3D_SCENE_LIGHTDIRECTION_1		"D3DSceneLightDirection1"
#define	UNO_NAME_3D_SCENE_LIGHTDIRECTION_2		"D3DSceneLightDirection2"
#define	UNO_NAME_3D_SCENE_LIGHTDIRECTION_3		"D3DSceneLightDirection3"
#define	UNO_NAME_3D_SCENE_LIGHTDIRECTION_4		"D3DSceneLightDirection4"
#define	UNO_NAME_3D_SCENE_LIGHTDIRECTION_5		"D3DSceneLightDirection5"
#define	UNO_NAME_3D_SCENE_LIGHTDIRECTION_6		"D3DSceneLightDirection6"
#define	UNO_NAME_3D_SCENE_LIGHTDIRECTION_7		"D3DSceneLightDirection7"
#define	UNO_NAME_3D_SCENE_LIGHTDIRECTION_8		"D3DSceneLightDirection8"
#define	UNO_NAME_3D_SCENE_AMBIENTCOLOR			"D3DSceneAmbientColor"
#define	UNO_NAME_3D_SCENE_SHADOW_SLANT			"D3DSceneShadowSlant"
#define	UNO_NAME_3D_SCENE_SHADE_MODE			"D3DSceneShadeMode"

#define	UNO_NAME_3D_DOUBLE_SIDED				"D3DDoubleSided"
#define	UNO_NAME_3D_NORMALS_KIND				"D3DNormalsKind"
#define	UNO_NAME_3D_NORMALS_INVERT				"D3DNormalsInvert"
#define	UNO_NAME_3D_TEXTURE_PROJ_X				"D3DTextureProjectionX"
#define	UNO_NAME_3D_TEXTURE_PROJ_Y				"D3DTextureProjectionY"
#define	UNO_NAME_3D_SHADOW_3D					"D3DShadow3D"
#define	UNO_NAME_3D_MAT_COLOR					"D3DMaterialColor"
#define	UNO_NAME_3D_MAT_EMISSION				"D3DMaterialEmission"
#define	UNO_NAME_3D_MAT_SPECULAR				"D3DMaterialSpecular"
#define	UNO_NAME_3D_MAT_SPECULAR_INTENSITY		"D3DMaterialSpecularIntensity"
#define	UNO_NAME_3D_TEXTURE_KIND				"D3DTextureKind"
#define	UNO_NAME_3D_TEXTURE_MODE				"D3DTextureMode"
#define	UNO_NAME_3D_TEXTURE_FILTER				"D3DTextureFilter"

#define	UNO_NAME_3D_HORZ_SEGS					"D3DHorizontalSegments"
#define	UNO_NAME_3D_VERT_SEGS					"D3DVerticalSegments"

#define	UNO_NAME_3D_PERCENT_DIAGONAL			"D3DPercentDiagonal"
#define	UNO_NAME_3D_BACKSCALE					"D3DBackscale"
#define	UNO_NAME_3D_LATHE_END_ANGLE				"D3DEndAngle"

#define	UNO_NAME_3D_EXTRUDE_DEPTH				"D3DDepth"

#define	UNO_NAME_3D_TRANSFORM_MATRIX			"D3DTransformMatrix"
#define	UNO_NAME_3D_CAMERA_GEOMETRY				"D3DCameraGeometry"
#define	UNO_NAME_3D_POS							"D3DPosition"
#define	UNO_NAME_3D_SIZE						"D3DSize"
#define	UNO_NAME_3D_POS_IS_CENTER				"D3DPositionIsCenter"
#define	UNO_NAME_3D_POLYPOLYGON3D				"D3DPolyPolygon3D"
#define	UNO_NAME_3D_NORMALSPOLYGON3D			"D3DNormalsPolygon3D"
#define	UNO_NAME_3D_TEXTUREPOLYGON3D			"D3DTexturePolygon3D"
#define	UNO_NAME_3D_LINEONLY					"D3DLineOnly"

// #107245# New 3D properties which are possible for lathe and extrude 3d objects
#define UNO_NAME_3D_SMOOTH_NORMALS				"D3DSmoothNormals"
#define UNO_NAME_3D_SMOOTH_LIDS					"D3DSmoothLids"
#define UNO_NAME_3D_CHARACTER_MODE				"D3DCharacterMode"
#define UNO_NAME_3D_CLOSE_FRONT					"D3DCloseFront"
#define UNO_NAME_3D_CLOSE_BACK					"D3DCloseBack"

#define UNO_NAME_NUMBERING						"IsNumbering"
#define UNO_NAME_NUMBERING_RULES				"NumberingRules"
#define UNO_NAME_NUMBERING_LEVEL                "NumberingLevel"

#define UNO_NAME_NRULE_NUMBERINGTYPE			"NumberingType"
#define UNO_NAME_NRULE_PREFIX					"Prefix"
#define UNO_NAME_NRULE_SUFFIX					"Suffix"
#define UNO_NAME_NRULE_BULLETID					"BulletId"
#define UNO_NAME_NRULE_BULLET_COLOR				"BulletColor"
#define UNO_NAME_NRULE_BULLET_RELSIZE			"BulletRelSize"
#define UNO_NAME_NRULE_BULLET_FONT				"BulletFont"
#define UNO_NAME_NRULE_GRAPHICURL				"GraphicURL"
#define UNO_NAME_NRULE_START_WITH				"StartWith"
#define UNO_NAME_NRULE_LEFT_MARGIN				"LeftMargin"
#define UNO_NAME_NRULE_FIRST_LINE_OFFSET		"FirstLineOffset"
#define UNO_NAME_NRULE_ADJUST					"Adjust"

#define UNO_NAME_EDIT_FONT_DESCRIPTOR			"FontDescriptor"
#define UNO_NAME_EDIT_FONT_STYLENAME			"FontStyleName"

#define UNO_NAME_EDIT_PARA_ADJUST				"ParaAdjust"
#define UNO_NAME_EDIT_PARA_BMARGIN				"ParaBottomMargin"
#define UNO_NAME_EDIT_PARA_LASTLINEADJ			"ParaLastLineAdjust"
#define UNO_NAME_EDIT_PARA_LMARGIN				"ParaLeftMargin"
#define UNO_NAME_EDIT_PARA_LRPARAMARGIN			"ParaLeftRightParaMargin"
#define UNO_NAME_EDIT_PARA_LINESPACING			"ParaLineSpacing"
#define UNO_NAME_EDIT_PARA_RMARGIN				"ParaRightMargin"
#define UNO_NAME_EDIT_PARA_TAPSTOPS				"ParaTabStops"
#define UNO_NAME_EDIT_PARA_TBMARGIN				"ParaTopBottomMargin"
#define UNO_NAME_EDIT_PARA_TMARGIN				"ParaTopMargin"
#define UNO_NAME_EDIT_PARA_IS_HYPHEN			"ParaIsHyphenation"
#define UNO_NAME_EDIT_PARA_IS_HANGING_PUNCTUATION    "ParaIsHangingPunctuation"
#define UNO_NAME_EDIT_PARA_IS_CHARACTER_DISTANCE     "ParaIsCharacterDistance"
#define UNO_NAME_EDIT_PARA_IS_FORBIDDEN_RULES		"ParaIsForbiddenRules"
#define UNO_NAME_EDIT_PARA_FIRST_LINE_INDENT	"ParaFirstLineIndent"

#define UNO_NAME_EDIT_CHAR_HEIGHT				"CharHeight"
#define UNO_NAME_EDIT_CHAR_FONTNAME				"CharFontName"
#define UNO_NAME_EDIT_CHAR_FONTSTYLENAME		"CharFontStyleName"
#define UNO_NAME_EDIT_CHAR_FONTFAMILY			"CharFontFamily"
#define UNO_NAME_EDIT_CHAR_FONTCHARSET			"CharFontCharSet"
#define UNO_NAME_EDIT_CHAR_FONTPITCH			"CharFontPitch"
#define UNO_NAME_EDIT_CHAR_POSTURE				"CharPosture"
#define UNO_NAME_EDIT_CHAR_WEIGHT				"CharWeight"
#define UNO_NAME_EDIT_CHAR_LOCALE				"CharLocale"

#define UNO_NAME_EDIT_CHAR_HEIGHT_ASIAN         "CharHeightAsian"
#define UNO_NAME_EDIT_CHAR_FONTNAME_ASIAN		"CharFontNameAsian"
#define UNO_NAME_EDIT_CHAR_FONTSTYLENAME_ASIAN	"CharFontStyleNameAsian"
#define UNO_NAME_EDIT_CHAR_FONTFAMILY_ASIAN		"CharFontFamilyAsian"
#define UNO_NAME_EDIT_CHAR_FONTCHARSET_ASIAN	"CharFontCharSetAsian"
#define UNO_NAME_EDIT_CHAR_FONTPITCH_ASIAN		"CharFontPitchAsian"
#define UNO_NAME_EDIT_CHAR_POSTURE_ASIAN		"CharPostureAsian"
#define UNO_NAME_EDIT_CHAR_WEIGHT_ASIAN			"CharWeightAsian"
#define UNO_NAME_EDIT_CHAR_LOCALE_ASIAN			"CharLocaleAsian"

#define UNO_NAME_EDIT_CHAR_HEIGHT_COMPLEX		"CharHeightComplex"
#define UNO_NAME_EDIT_CHAR_FONTNAME_COMPLEX		"CharFontNameComplex"
#define UNO_NAME_EDIT_CHAR_FONTSTYLENAME_COMPLEX "CharFontStyleNameComplex"
#define UNO_NAME_EDIT_CHAR_FONTFAMILY_COMPLEX	"CharFontFamilyComplex"
#define UNO_NAME_EDIT_CHAR_FONTCHARSET_COMPLEX	"CharFontCharSetComplex"
#define UNO_NAME_EDIT_CHAR_FONTPITCH_COMPLEX	"CharFontPitchComplex"
#define UNO_NAME_EDIT_CHAR_POSTURE_COMPLEX		"CharPostureComplex"
#define UNO_NAME_EDIT_CHAR_WEIGHT_COMPLEX		"CharWeightComplex"
#define UNO_NAME_EDIT_CHAR_LOCALE_COMPLEX		"CharLocaleComplex"

#define UNO_NAME_EDIT_CHAR_COLOR				"CharColor"
#define UNO_NAME_EDIT_CHAR_CROSSEDOUT			"CharCrossedOut"
#define UNO_NAME_EDIT_CHAR_STRIKEOUT			"CharStrikeout"
#define UNO_NAME_EDIT_CHAR_ESCAPEMENT			"CharEscapement"
#define UNO_NAME_EDIT_CHAR_FONTNAME				"CharFontName"
#define UNO_NAME_EDIT_CHAR_SHADOWED				"CharShadowed"
#define UNO_NAME_EDIT_CHAR_UNDERLINE			"CharUnderline"

#define UNO_NAME_BITMAP							"Bitmap"

#define UNO_NAME_LINKDISPLAYNAME				"LinkDisplayName"
#define UNO_NAME_LINKDISPLAYBITMAP				"LinkDisplayBitmap"

#define UNO_NAME_GRAPHIC_LUMINANCE				"AdjustLuminance"
#define UNO_NAME_GRAPHIC_CONTRAST				"AdjustContrast"
#define UNO_NAME_GRAPHIC_RED					"AdjustRed"
#define UNO_NAME_GRAPHIC_GREEN					"AdjustGreen"
#define UNO_NAME_GRAPHIC_BLUE					"AdjustBlue"
#define UNO_NAME_GRAPHIC_GAMMA					"Gamma"
#define UNO_NAME_GRAPHIC_TRANSPARENCY			"Transparency"
#define UNO_NAME_GRAPHIC_COLOR_MODE				"GraphicColorMode"
#define UNO_NAME_GRAPHIC_GRAPHICCROP			"GraphicCrop"

#define UNO_NAME_AUTOSHAPE_ADJUSTMENT			"AutoShapeAdjustment"

// Die folgenden Properties sind veraltet und koennen irgendwann mal raus
#define UNO_NAME_EDIT_FONT_COLOR				"FontColor"
#define UNO_NAME_EDIT_FONT_ESCAPEMENT			"FontEscapement"
#define UNO_NAME_EDIT_FONT_HEIGHT				"FontHeight"
#define UNO_NAME_EDIT_FONT_SHADOWED				"FontShadowed"
#define UNO_NAME_EDIT_FONT_SLANT				"FontSlant"
#define UNO_NAME_EDIT_FONT_STRIKEOUT			"FontStrikeout"
#define UNO_NAME_EDIT_FONT_UNDERLINE			"FontUnderline"
#define UNO_NAME_EDIT_FONT_WEIGHT				"FontWeight"
#define UNO_NAME_EDIT_CHAR_STYLE				"CharStyle"
#define UNO_NAME_EDIT_FONT_FAMILY				"FontFamily"
#define UNO_NAME_EDIT_FONT_NAME					"FontName"
#define UNO_NAME_EDIT_FONT_CHARSET				"FontCharset"
// Ende der veralteten Properties

}//end of namespace binfilter
#endif

